from environment_setup import *

def create_target_box():
    # creates target box st. launch_box will launch a box at the target box
    BOX_WIDTH = 0.07
    BOX_LENGTH = 0.05
    BOX_HEIGHT = 0.15
    pybullet_planning.create_box(BOX_WIDTH, BOX_LENGTH, BOX_HEIGHT, color=pybullet_planning.RED)
    box_geometry = pybullet_planning.get_box_geometry(BOX_WIDTH, BOX_LENGTH, BOX_HEIGHT)
    collision_id, visual_id = pybullet_planning.create_shape(geometry=box_geometry)
    body_id = pybullet_planning.create_body(collision_id, visual_id)
    pybullet_planning.set_point(body_id, pybullet_planning.Point(0, 5, 0))
    pybullet_planning.set_point(visual_id, pybullet_planning.Point(0, 5, 0))
    pybullet_planning.set_point(collision_id, pybullet_planning.Point(0, 5, 0))
    return body_id
    
if __name__=="__main__":
    initialize_environment()
    body_id = create_target_box()
    launch_box(body_id)
    while simulation_is_running():
        if any_key_is_pressed():
            spawn_object(obj=uniform_object(), size=uniform_size(), color=uniform_color())